package me.km.blocks;

import java.util.List;
import java.util.Random;
import javax.annotation.Nullable;
import static net.minecraft.block.BlockBed.PART;
import net.minecraft.block.SoundType;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

public class BlockBed extends net.minecraft.block.BlockBed
{
    protected String name;
    private SoundType type;
    private final Item drop;
    private static final AxisAlignedBB BOX = new AxisAlignedBB(0, 0, 0, 1, 0.125d, 1);
    private static final AxisAlignedBB BOX_2 = new AxisAlignedBB(0, 0, 0.625d, 1, 0.25d, 1);
    
    public BlockBed(String name, String local, Item drop)
    {
        this.name = name;
        this.setRegistryName(name);
        super.setUnlocalizedName(local);
        this.type = SoundType.CLOTH;
        this.drop = drop;
        super.setHardness(0.2F);
        super.disableStats();
    }
    
    @Override
    public void addCollisionBoxToList(IBlockState state, World worldIn, BlockPos pos, AxisAlignedBB entityBox, List<AxisAlignedBB> collidingBoxes, @Nullable Entity entityIn, boolean p_185477_7_)
    {
        addCollisionBoxToList(pos, entityBox, collidingBoxes, BOX);
        addCollisionBoxToList(pos, entityBox, collidingBoxes, BOX_2);
    }

    @Override
    public AxisAlignedBB getBoundingBox(IBlockState state, IBlockAccess source, BlockPos pos)
    {
        return state.getValue(PART) == BlockBed.EnumPartType.HEAD ? FULL_BLOCK_AABB : BOX;
    }
    
    @Override
    public final Item getItemDropped(IBlockState state, Random rand, int fortune)
    {
        return state.getValue(PART) == BlockBed.EnumPartType.HEAD ? Items.AIR : drop;
    }

    @Override
    public ItemStack getItem(World worldIn, BlockPos pos, IBlockState state) 
    {
        return new ItemStack(drop);
    }

    @Override
    public BlockBed setSoundType(SoundType sound) 
    {
        this.type = sound;
        return this;
    }

    @Override
    public SoundType getSoundType(IBlockState state, World w, BlockPos pos, Entity entity) 
    {
        return type;
    }     

    @Override
    public boolean isBed(IBlockState state, IBlockAccess world, BlockPos pos, Entity player) 
    {
        return true;
    }
}
