package me.km.blocks;

import me.km.fluids.BlockFluidBase;
import me.km.fluids.BlockFluidHoney;
import me.km.fluids.BlockFluidPoison;
import me.km.fluids.ModFluids;
import me.km.items.ModItems;
import net.minecraft.block.Block;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.item.ItemBlock;
import net.minecraftforge.fml.common.registry.GameRegistry;

public class ModBlocks 
{
    // ores + blocks
    public static BlockOre copperOre;
    public static BlockBase copperBlock;
    
    public static BlockOre tinOre;
    public static BlockBase tinBlock;
    
    public static BlockBase bronzeBlock;
    
    // misc
    public static BlockBase guildblock;
    public static BlockHay realHayBlock;
    public static BlockBed realHayBed;
    
    // fluids
    public static BlockFluidPoison poison;
    public static BlockFluidHoney honey;
    
    public static void init() 
    {
        // ores + blocks
        copperOre = register(new BlockOre("copper_ore", "oreCopper"));      
        copperBlock = register((BlockBase) new BlockBase(Material.IRON, "copper_block", "blockCopper")
                .setHardness(3).setResistance(10));
        tinOre = register(new BlockOre("tin_ore", "oreTin"));      
        tinBlock = register((BlockBase) new BlockBase(Material.IRON, "tin_block", "blockTin")
                .setHardness(3).setResistance(5));
        bronzeBlock = register((BlockBase) new BlockBase(Material.IRON, "bronze_block", "blockBronze")
                .setHardness(5).setResistance(10));
        
        // misc
        guildblock = register((BlockBase) new BlockBase(Material.IRON, "guild_block", "blockGuild")
                .setHardness(50.0F).setResistance(2000.0F));
        realHayBlock = register((BlockHay) new BlockHay("real_hay_block", "realHayBlock")
                .setSoundType(SoundType.PLANT).setHardness(0.5F));
        realHayBed = registerBlock(new BlockBed("real_hay_bed", "realHayBlock", ModItems.realHayBed));
    
        // fluids
        poison = register(new BlockFluidPoison(ModFluids.poison, Material.WATER));
        honey = register(new BlockFluidHoney(ModFluids.honey, Material.WATER));
    }

    private static <T extends Block> T register(T block, ItemBlock itemBlock) 
    {
        GameRegistry.register(block);
        GameRegistry.register(itemBlock);
        if(block instanceof IBlockBase) 
        {
            ((IBlockBase) block).registerItemModel(itemBlock);
        }
        if(block instanceof BlockFluidBase) 
        {
            ((BlockFluidBase) block).registerBlockModel();
        }
        return block;
    }
    
    private static <T extends Block> T registerBlock(T block) 
    {
        GameRegistry.register(block);
        return block;
    }

    private static <T extends Block> T register(T block) 
    {
        ItemBlock itemBlock = new ItemBlock(block);
        itemBlock.setRegistryName(block.getRegistryName());
        return register(block, itemBlock);
    }
}
